#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <locale.h>

#define MAX_FUNCTIONS 100

typedef void(*FunctionPointer)(); //    

typedef struct
{
	FunctionPointer functions[MAX_FUNCTIONS];
	int count;
} Delegate;

void initDelegate(Delegate* delegate)
{
	delegate->count = 0;
}

int addFunctions(Delegate* delegate, FunctionPointer func)
{
	if (delegate->count >= MAX_FUNCTIONS)
	{
		return -1; // 
	}
	delegate->functions[delegate->count++] = func;
	{
		return 0;//
	}
}

void callFunctions(const Delegate* delegate)
{
	for (int i = 0; i < delegate->count; i++)
	{
		delegate->functions[i]();
		
	}
	printf("\n");
}

int removeFunctions(Delegate* delegate, FunctionPointer func)
{
	for (int i = 0; i < delegate->count; i++)
	{
		if (delegate->functions[i] == func)
		{
			for (int j = i; j < delegate->count - 1; j++)			
				{
					delegate->functions[j] = delegate->functions[j + 1];
				}
				delegate->count--;
				return 0; //			
		}	
			
	}
	return -1; //  	
}

void removeDelegate(Delegate* delegate)
{
	for (int i = 0; i < delegate->count; i++)
	{
		for (int j = i + 1; j < delegate->count; j++)
		{
			if (delegate->functions[i] == delegate->functions[j])
			{
				removeFunctions(delegate, delegate->functions[j]);
				j--;
			}
		}
	}
	for (int i = 0; i < delegate->count; i++)
	{
		for (int j = i + 1; j < delegate->count; j++)
		{
			if (delegate->functions[i] == delegate->functions[j])
			{
				removeFunctions(delegate, delegate->functions[j]);
				j--;
			}
		}
	}
}

void One()
{
	printf("  1\n");
}

void Two()
{
	printf("  2\n");
}

void Three()
{
	printf("  3\n");
}

int main()
{
	setlocale(LC_ALL, "Russian");
	Delegate delegat;

	initDelegate(&delegat);

	addFunctions(&delegat, One);
	addFunctions(&delegat, One);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, One);
	addFunctions(&delegat, One);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, One);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Two);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);
	addFunctions(&delegat, Three);

	callFunctions(&delegat);
	
	removeDelegate(&delegat);
	
	callFunctions(&delegat);

	removeFunctions(&delegat, One);

	callFunctions(&delegat);

	return 0;
}

